/*
 Copyright (C) 1996 Mike White
 Permission is granted to any individual or institution to use, copy, or
 redistribute this software so long as all of the original files are included,
 that it is not sold for profit, and that this copyright notice is retained.

*/

#include <windows.h>
#include "wiz.h"
#include "..\unzip\zip.h"

#include "..\unzip\crypt.h"
#ifdef CRYPT
#  include "password.h"
#  include "helpids.h"

char *prompt;
char *szPassword;
LPSTR lpPasswordStr;

/****************************************************************************

    FUNCTION: PasswordProc(HWND, WORD, WPARAM, LPARAM)

    PURPOSE:  Processes messages for "Password" dialog box

    MESSAGES:

    WM_INITDIALOG - initialize dialog box
    WM_COMMAND    - Input received

****************************************************************************/
BOOL WINAPI PasswordProc(HWND hDlg, WORD wMessage, WPARAM wParam, LPARAM lParam)
{
char szBuffer[256];
    switch (wMessage)
    {
    case WM_INITDIALOG:
        SetDlgItemText(hDlg, IDM_PASSWORD_INCORRECT, prompt);

        if ((LPSTR)lParam != NULL)
           {
           wsprintf(szBuffer, "Enter Password for %s", (LPSTR)lParam);
           SetDlgItemText(hDlg, IDM_PASSWORD_TEXT, szBuffer);
           }
        SetDlgItemText(hDlg, IDM_NEW_PASSWORD_NAME_TEXT, "");
        CenterDialog(GetParent(hDlg), hDlg); /* center on parent */
        return TRUE;

    case WM_SETFOCUS:
        SetFocus(GetDlgItem(hDlg, IDM_NEW_PASSWORD_NAME_TEXT));
        return TRUE;

    case WM_COMMAND:
        switch (LOWORD(wParam))
        {
        case IDM_PASSWORD_RENAME:
            GetDlgItemText(hDlg, IDM_NEW_PASSWORD_NAME_TEXT, lpPasswordStr, 80);
            EndDialog(hDlg, wParam);
            break;
        case IDM_PASSWORD_CANCEL:
            szPassword[0] = '\0';
            EndDialog(hDlg, wParam);
            break;
        case IDM_PASSWORD_HELP:
            WinHelp(hDlg,szHelpFileName,HELP_CONTEXT, (DWORD)(HELPID_PASSWORD));
            break;
        }
        return TRUE;
    }
    return FALSE;
}

char far * WINAPI password(char *p, char *m, int n, char * name)
{
FARPROC lpProcPassword;
prompt = (char *)malloc(n);
szPassword = (char *)malloc(n);
lpPasswordStr = szPassword;

lpProcPassword = MakeProcInstance(PasswordProc, hInst);
lstrcpy(prompt, m);

DialogBoxParam(hInst, "Password", hWndMain, lpProcPassword,
   (DWORD)(LPSTR)name);

#ifndef WIN32
    FreeProcInstance(lpProcPassword);
#endif
    lstrcpy(p, szPassword);
    free(szPassword);
    free(prompt);
    return p;
}

#endif /* CRYPT */

