/*
 Copyright (C) 1996 Mike White
 Permission is granted to any individual or institution to use, copy, or
 redistribute this software so long as all of the original files are included,
 that it is not sold for profit, and that this copyright notice is retained.

*/

#include <windows.h>
#include <stdio.h>
#include "wiz.h"
#include "helpids.h"
#include "ziperr.h"

ZCL zcl;
LPZCL  lpZCL;
int ZipRetCode;
BOOL fSaveZipToDir;
BOOL fSaveUnZipFromDir;

char szFilesToAdd[80];
HWND hGetFilesDlg;

/* Forward references */
void WriteZipOptionsProfile(void);
void ReadZipOptionsProfile(void);

void GetWizOptions()
{
ReadZipOptionsProfile();
}

void ReadZipOptionsProfile()
{
char szZipOptions[80];
/* NOTE: lpZCL->fLevel defaults to 6 unless specified otherwise */
char szZipOptionsDefault[] = "600000000000000000001010011011100100";
int i=0;
BOOL flag = FALSE;

GetPrivateProfileString(szAppName, szZipOptionKey, szZipOptionsDefault,
   szZipOptions, 80, szWiZIniFile);

if (lstrlen(szZipOptions) != lstrlen(szZipOptionsDefault))
   {
   lstrcpy(szZipOptions, szZipOptionsDefault);
   flag = TRUE;
   }

lpZCL->fLevel         = szZipOptions[i++];
lpZCL->fSuffix        = szZipOptions[i++]-'0';
lpZCL->fEncrypt       = szZipOptions[i++]-'0';
lpZCL->fSystem        = szZipOptions[i++]-'0';
lpZCL->fVolume        = szZipOptions[i++]-'0';
lpZCL->fExtra         = szZipOptions[i++]-'0';
lpZCL->fNoDirEntries  = szZipOptions[i++]-'0';
lpZCL->fVerbose       = szZipOptions[i++]-'0';
lpZCL->fQuiet         = szZipOptions[i++]-'0';
lpZCL->fCRLF_LF       = szZipOptions[i++]-'0';
lpZCL->fLF_CRLF       = szZipOptions[i++]-'0';
lpZCL->fJunkDir       = szZipOptions[i++]-'0';
lpZCL->fRecurse       = szZipOptions[i++]-'0';
lpZCL->fGrow          = szZipOptions[i++]-'0';
lpZCL->fForce         = szZipOptions[i++]-'0';
lpZCL->fMove          = szZipOptions[i++]-'0';
lpZCL->fUpdate        = szZipOptions[i++]-'0';
lpZCL->fFreshen       = szZipOptions[i++]-'0';
lpZCL->fLatestTime    = szZipOptions[i++]-'0';
lpZCL->fComment       = szZipOptions[i++]-'0';
fSaveZipToDir      = szZipOptions[i++]-'0';
lpDCL->Overwrite      = szZipOptions[i++]-'0';
lpDCL->PromptToOverwrite = szZipOptions[i++]-'0';
lpDCL->ExtractOnlyNewer = szZipOptions[i++]-'0';
lpDCL->SpaceToUnderscore = szZipOptions[i++]-'0';
uf.fSaveUnZipToDir     = szZipOptions[i++]-'0';
uf.fSaveUnZipFromDir   = szZipOptions[i++]-'0';
uf.fTranslate          = szZipOptions[i++]-'0';
uf.fRecreateDirs       = szZipOptions[i++]-'0';
uf.fFormatLong         = szZipOptions[i++]-'0';
uf.fShowBubbleHelp     = szZipOptions[i++]-'0';
uf.fUnzipToZipDir      = szZipOptions[i++]-'0';
fMakeSFX               = szZipOptions[i++]-'0';
fLB_Selection          = szZipOptions[i++]-'0';
lpDCL->fPrivilege      = szZipOptions[i++]-'0';
lpZCL->fPrivilege      = szZipOptions[i] - '0';

/* If this is a 16 bit version, or if we are not running on NT, force
   disabling of privilege/acl stuff
 */
#ifdef WIN32
if (!dwPlatformId)
#endif
   {
   lpDCL->fPrivilege = FALSE;
   lpZCL->fPrivilege = FALSE;
   }
/* Verify that all entries are valid */
if ((lpZCL->fLevel < '0') || (lpZCL->fLevel > '9'))
   {
   lpZCL->fLevel = '6'; /* Set compression level to default */
   flag = TRUE;
   }
if ((lpZCL->fPrivilege < 0) || (lpZCL->fPrivilege > 3))
   {
   lpZCL->fPrivilege = 0; /* Turn off privilege */
   flag = TRUE;
   }
if ((lpDCL->fPrivilege < 0) || (lpDCL->fPrivilege > 3))
   {
   lpDCL->fPrivilege = 0; /* Turn off privilege */
   flag = TRUE;
   }
if ((lpZCL->fSuffix != 0) && (lpZCL->fSuffix != 1))
   {
   lpZCL->fSuffix = 0;
   flag = TRUE;
   }
if ((lpZCL->fEncrypt!= 0) && (lpZCL->fEncrypt!= 1))
   {
   lpZCL->fEncrypt= 0;
   flag = TRUE;
   }
if ((lpZCL->fSystem!= 0) && (lpZCL->fSystem!= 1))
   {
   lpZCL->fSystem= 0;
   flag = TRUE;
   }
if ((lpZCL->fVolume!= 0) && (lpZCL->fVolume!= 1))
   {
   lpZCL->fVolume= 0;
   flag = TRUE;
   }
if ((lpZCL->fExtra!= 0) && (lpZCL->fExtra!= 1))
   {
   lpZCL->fExtra= 0;
   flag = TRUE;
   }
if ((lpZCL->fNoDirEntries!= 0) && (lpZCL->fNoDirEntries!= 1))
   {
   lpZCL->fNoDirEntries= 0;
   flag = TRUE;
   }
if ((lpZCL->fVerbose!= 0) && (lpZCL->fVerbose!= 1))
   {
   lpZCL->fVerbose= 0;
   flag = TRUE;
   }
if ((lpZCL->fQuiet!= 0) && (lpZCL->fQuiet!= 1))
   {
   lpZCL->fQuiet= 0;
   flag = TRUE;
   }
if ((lpZCL->fCRLF_LF!= 0) && (lpZCL->fCRLF_LF!= 1))
   {
   lpZCL->fCRLF_LF= 0;
   flag = TRUE;
   }
if ((lpZCL->fLF_CRLF!= 0) && (lpZCL->fLF_CRLF!= 1))
   {
   lpZCL->fLF_CRLF= 0;
   flag = TRUE;
   }
if ((lpZCL->fJunkDir!= 0) && (lpZCL->fJunkDir!= 1))
   {
   lpZCL->fJunkDir= 0;
   flag = TRUE;
   }
if ((lpZCL->fRecurse!= 0) && (lpZCL->fRecurse!= 1))
   {
   lpZCL->fRecurse= 0;
   flag = TRUE;
   }
if ((lpZCL->fGrow!= 0) && (lpZCL->fGrow!= 1))
   {
   lpZCL->fGrow= 0;
   flag = TRUE;
   }
if ((lpZCL->fForce!= 0) && (lpZCL->fForce!= 1))
   {
   lpZCL->fForce= 0;
   flag = TRUE;
   }
if ((lpZCL->fMove!= 0) && (lpZCL->fMove!= 1))
   {
   lpZCL->fMove= 0;
   flag = TRUE;
   }
if ((lpZCL->fUpdate!= 0) && (lpZCL->fUpdate!= 1))
   {
   lpZCL->fUpdate= 0;
   flag = TRUE;
   }
if ((lpZCL->fFreshen!= 0) && (lpZCL->fFreshen!= 1))
   {
   lpZCL->fFreshen= 0;
   flag = TRUE;
   }
lpZCL->fJunkSFX = 0;
if ((lpZCL->fLatestTime != 0) && (lpZCL->fLatestTime != 1))
   {
   lpZCL->fLatestTime = 0;
   flag = TRUE;
   }
if ((lpZCL->fComment != 0) && (lpZCL->fComment != 1))
   {
   lpZCL->fComment = 0;
   flag = TRUE;
   }
if ((fSaveZipToDir != 0) && (fSaveZipToDir != 1))
   {
   fSaveZipToDir = 0;
   flag = TRUE;
   }
if ((lpDCL->Overwrite != 0) && (lpDCL->Overwrite != 1))
   {
   lpDCL->Overwrite = 0;
   flag = TRUE;
   }
if ((lpDCL->PromptToOverwrite != 0) && (lpDCL->PromptToOverwrite != 1))
   {
   lpDCL->PromptToOverwrite = 0;
   flag = TRUE;
   }
if ((lpDCL->ExtractOnlyNewer != 0) && (lpDCL->ExtractOnlyNewer != 1))
   {
   lpDCL->ExtractOnlyNewer = 0;
   flag = TRUE;
   }
if ((lpDCL->SpaceToUnderscore != 0) && (lpDCL->SpaceToUnderscore != 1))
   {
   lpDCL->SpaceToUnderscore = 0;
   flag = TRUE;
   }
if ((uf.fSaveUnZipToDir != 0) && (uf.fSaveUnZipToDir != 1))
   {
   uf.fSaveUnZipToDir = 0;
   flag = TRUE;
   }
if ((uf.fSaveUnZipFromDir != 0) && (uf.fSaveUnZipFromDir != 1))
   {
   uf.fSaveUnZipFromDir = 0;
   flag = TRUE;
   }
if ((uf.fTranslate != 0) && (uf.fTranslate != 1))
   {
   uf.fTranslate = 0;
   flag = TRUE;
   }
if ((uf.fRecreateDirs != 0) && (uf.fRecreateDirs != 1))
   {
   uf.fRecreateDirs = 0;
   flag = TRUE;
   }
if ((uf.fFormatLong != 0) && (uf.fFormatLong != 1))
   {
   uf.fFormatLong = 0;
   flag = TRUE;
   }
if ((uf.fShowBubbleHelp != 0) && (uf.fShowBubbleHelp != 1))
   {
   uf.fShowBubbleHelp = 0;
   flag = TRUE;
   }
if ((uf.fUnzipToZipDir != 0) && (uf.fUnzipToZipDir != 1))
   {
   uf.fUnzipToZipDir = 0;
   flag = TRUE;
   }
if ((fMakeSFX != 0) && (fMakeSFX != 1))
   {
   fMakeSFX = 0;
   flag = TRUE;
   }
if ((fLB_Selection < 0) || (fLB_Selection > 2))
   {
   fLB_Selection = 1;
   wLBSelection = IDM_LB_DISPLAY; /* default listbox selection action */
   flag = TRUE;
   }
else
   {
   switch (fLB_Selection)
      {
      case 0:
              wLBSelection = IDM_LB_EXTRACT;
              break;
      case 1:
              wLBSelection = IDM_LB_DISPLAY;
              break;
      case 2:
              wLBSelection = IDM_LB_TEST;
              break;
      }
   }

   /* We never want these options to be saved, or restored */
lpZCL->fDate= FALSE;     /* Date option */
lpZCL->fOffsets = FALSE; /* Adjust offsets option */
lpZCL->fRepair = FALSE;  /* Fix archive options */

/* Under WIN32 only long format is supported */
#ifdef WIN32
uf.fFormatLong = TRUE;
#endif

/* All entries have now been validated. */
CheckMenuItem(hMenu, IDM_SHOW_BUBBLE_HELP, MF_BYCOMMAND|
   (WORD)(uf.fShowBubbleHelp ? MF_CHECKED : MF_UNCHECKED));
CheckMenuItem(hMenu, IDM_SHORT, MF_BYCOMMAND|
   (WORD)(uf.fFormatLong ? MF_UNCHECKED : MF_CHECKED));
CheckMenuItem(hMenu, IDM_LONG, MF_BYCOMMAND|
   (WORD)(uf.fFormatLong ? MF_CHECKED : MF_UNCHECKED));
CheckMenuItem(hMenu, IDM_RECR_DIR_STRUCT, MF_BYCOMMAND |
             (uf.fRecreateDirs ? MF_CHECKED : MF_UNCHECKED));

CheckMenuItem(hMenu, IDM_SAVE_UNZIP_TO_DIR, MF_BYCOMMAND |
             (uf.fSaveUnZipToDir ? MF_CHECKED : MF_UNCHECKED));
CheckMenuItem(hMenu, IDM_SAVE_UNZIP_FROM_DIR, MF_BYCOMMAND |
             (uf.fSaveUnZipFromDir ? MF_CHECKED : MF_UNCHECKED));
CheckMenuItem(hMenu, wLBSelection, MF_BYCOMMAND | MF_CHECKED);
CheckMenuItem(hMenu, IDM_UNZIP_TO_ZIP_DIR, MF_BYCOMMAND |
             (uf.fUnzipToZipDir ? MF_CHECKED : MF_UNCHECKED));
EnableMenuItem(hMenu, IDM_CHDIR, MF_BYCOMMAND |
             (uf.fUnzipToZipDir ? MF_GRAYED : MF_ENABLED));
CheckMenuItem(hMenu, IDM_SAVE_ZIP_TO_DIR, MF_BYCOMMAND |
   (fSaveZipToDir ? MF_CHECKED : MF_UNCHECKED));


if (flag) /* Something was wrong with the options string, re-write it */
   WriteZipOptionsProfile();

/* Get default "Zip To" directory */
GetPrivateProfileString(szAppName, szZipToDirKey, "", szTargetZipDir,
   PATH_MAX, szWiZIniFile);
/* Get default "unzip-to" directory */
GetPrivateProfileString(szAppName, szDefaultUnzipToDir, "", szUnzipToDirName, PATH_MAX, szWiZIniFile);
/* Get default "unzip-from" directory */
GetPrivateProfileString(szAppName, szDefaultUnzipFromDir, "", lpumb->szUnzipFromDirName, PATH_MAX, szWiZIniFile);
}

/* WriteZipOptionsProfile simply writes the WiZ options out to one string,
   rather than having an entire series of profile strings in the .ini file
*/
void WriteZipOptionsProfile()
{
char szZipOptions[80];
sprintf(szZipOptions,
   "%c%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u%u",
   lpZCL->fLevel,
   lpZCL->fSuffix,
   lpZCL->fEncrypt,
   lpZCL->fSystem,
   lpZCL->fVolume,
   lpZCL->fExtra,
   lpZCL->fNoDirEntries,
   lpZCL->fVerbose,
   lpZCL->fQuiet,
   lpZCL->fCRLF_LF,
   lpZCL->fLF_CRLF,
   lpZCL->fJunkDir,
   lpZCL->fRecurse,
   lpZCL->fGrow,
   lpZCL->fForce,
   lpZCL->fMove,
   lpZCL->fUpdate,
   lpZCL->fFreshen,
   lpZCL->fLatestTime,
   lpZCL->fComment,
   fSaveZipToDir,
   lpDCL->Overwrite,
   lpDCL->PromptToOverwrite,
   lpDCL->ExtractOnlyNewer,
   lpDCL->SpaceToUnderscore,
   uf.fSaveUnZipToDir,
   uf.fSaveUnZipFromDir,
   uf.fTranslate,
   uf.fRecreateDirs,
   uf.fFormatLong,
   uf.fShowBubbleHelp,
   uf.fUnzipToZipDir,
   fMakeSFX,
   fLB_Selection,
   lpDCL->fPrivilege,
   lpZCL->fPrivilege);
WritePrivateProfileString(szAppName, szZipOptionKey,
   szZipOptions, szWiZIniFile);

if (fSaveZipToDir)
   WritePrivateProfileString(szAppName, szZipToDirKey, szTargetZipDir,
      szWiZIniFile);
else
   WritePrivateProfileString(szAppName, szZipToDirKey, "",
      szWiZIniFile);
}

#ifdef __BORLANDC__
#pragma warn -par
#endif
void ZipWndProc(HWND hWnd, WORD wMessage, WPARAM wParam, LPARAM lParam)
{
RECT  rClient;
#ifndef WIN32
FARPROC lpfnPrefs;
#endif
switch (LOWORD(wParam))
   {
   case IDM_ZIP_TARGET:
         ZipRetCode = FALSE;
         MakeArchive(hWnd);
         lstrcpy(lpumb->szZipFileName, lpZCL->lpszZipFN);
         if (ZipRetCode == ZE_OK)
            {
            lstrcpy(lpumb->szFileName, lpumb->szZipFileName);
            UpdateListBox();
            WinAssert(hWndList);
            GetClientRect( hWndList, &rClient );
            OffsetRect( &rClient, 0, dyChar );
            rClient.top = rClient.bottom;
            rClient.bottom = rClient.top + (6*dyChar);
#ifndef WIN32
            SendMessage(hWndList, LB_SETSEL, 1, 0L);
#else
            ListViewSetSel(0, TRUE);
#endif
            UpdateButtons(); /* update state of buttons */
            SetCaption(hWnd);
            InvalidateRect( hWnd, &rClient, TRUE);
            }
         break;
   case IDM_ZIP_PREFERENCES:
         {
#ifndef WIN32
         lpfnPrefs = MakeProcInstance((FARPROC)ZipPreferencesProc, hInst);
         DialogBox(hInst, "ZIP_PREFS", hWnd, lpfnPrefs);
         FreeProcInstance(lpfnPrefs);
#else
         DialogBox(hInst, "ZIP_PREFS", hWnd, (DLGPROC)ZipPreferencesProc);
#endif
         }
         break;
   case IDM_UNZIP_PREFERENCES:
         {
#ifndef WIN32
         lpfnPrefs = MakeProcInstance((FARPROC)UnZipPreferencesProc, hInst);
         DialogBox(hInst, "UNZIP_PREFS", hWnd, lpfnPrefs);
         FreeProcInstance(lpfnPrefs);
#else
         DialogBox(hInst, "UNZIP_PREFS", hWnd, (DLGPROC)UnZipPreferencesProc);
#endif
         }
         break;
   }
return;
}
#ifdef __BORLANDC__
#pragma warn .par
#endif

